#lang slideshow
(require slideshow/play
         "person.rkt"
         "venn.rkt"
         "logo.rkt")

(provide overview-slides)

(define (overview-slides)
  (define prof (professor))
  
  (define plain-venn (make-venn #:icons? #f))
  (define venn-s 0.5)
  (define small-venn (scale plain-venn venn-s))

  (define big-prof (scale prof 2))

  (define (outline-slide #:title? [title? #f]
                         #:racket? [racket? title?]
                         #:venn? [venn? racket?]
                         #:prof? [prof? #t]
                         #:fade [fade-n 0])
    (slide
     #:title (if title? "Outline" "")
     #:name "Outline"
     (outline #:racket? racket?
              #:venn? venn?
              #:prof? prof?)))

  (define (outline #:racket? [racket? #t]
                   #:venn? [venn? #t]
                   #:prof? [prof? #t])
    (refocus (hc-append
              (* 1/8 client-w)
              ((if venn? values ghost) small-venn)
              ((if prof? values ghost) big-prof)
              ((if racket? values ghost) (scale logo 0.75)))
             big-prof))
  
  (outline-slide)
  (outline-slide #:venn? #t)
  (outline-slide #:racket? #t)
  (outline-slide #:title? #t)

  (play-n
   #:skip-first? #t
   #:skip-last? #t
   (lambda (n)
     (let ([n (fast-middle n)])
       (define p (cc-superimpose
                  (cellophane (outline #:venn? #f) (- 1 n))
                  (ghost plain-venn)))
       (define v (scale plain-venn (+ venn-s (* n (- 1 venn-s)))))
       (slide-pict p v small-venn plain-venn n)))))

(module+ main
  (overview-slides))
